RecordComparator (Hadoop 0.20.1+169.88 API)
Date: 2010-05-20

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.hadoop.record
Class RecordComparator

    java.lang.Object
      org.apache.hadoop.io.WritableComparator
          org.apache.hadoop.record.RecordComparator

All Implemented Interfaces:
  Comparator, RawComparator

    public abstract class RecordComparator

extends WritableComparator

A raw record comparator base class

Constructor Summary
`protected` | `RecordComparator(Class<? extends WritableComparable> recordClass)` Construct a raw `Record` comparison implementation.

Method Summary
`abstract int` | `compare(byte[] b1, int s1, int l1, byte[] b2, int s2, int l2)` Optimization hook.
`static void` | `define(Class c, RecordComparator comparator)` Register an optimized comparator for a `Record` implementation.

Methods inherited from class org.apache.hadoop.io.WritableComparator
`compare, compare, compareBytes, define, get, getKeyClass, hashBytes, hashBytes, newKey, readDouble, readFloat, readInt, readLong, readUnsignedShort, readVInt, readVLong`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.util.Comparator
`equals`

Constructor Detail

### RecordComparator

    protected RecordComparator(Class<? extends WritableComparable> recordClass)

  Construct a raw `Record` comparison implementation.

Method Detail

### compare

    public abstract int compare(byte[] b1,
                                int s1,
                                int l1,
                                byte[] b2,
                                int s2,
                                int l2)

  Description copied from class: `WritableComparator`
  Optimization hook. Override this to make SequenceFile.Sorter's scream.

  The default implementation reads the data into two `WritableComparable`s (using `Writable.readFields(DataInput)`, then calls `WritableComparator.compare(WritableComparable,WritableComparable)`.

  Specified by:
    `compare` in interface `RawComparator`
  Overrides:
    `compare` in class `WritableComparator`

### define

    public static void define(Class c,
                              RecordComparator comparator)

  Register an optimized comparator for a `Record` implementation.

  Parameters:
    `c` - record classs for which a raw comparator is provided
    `comparator` - Raw comparator instance for class c

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 The Apache Software Foundation